## openmodelica 22929

=== 3rdParty/SuiteSparse/CMakeLists.txt ===
project(umfpack_package)
cmake_minimum_required(VERSION 2.8.9)
include(ExternalProject)
include(Helpers.cmake)
set(SS_VERSION "3.0.0")

#for shared, at least in cmake 2.8.12:
set(CMAKE_POSITION_INDEPENDENT_CODE ON)

option(DOWNLOAD_SUITESPARSE "download suitesparse package, version ${SS_VERSION}" OFF)
option(WITH_BLAS "enable blas support" OFF)
option(WITH_CHOLMOD "enable cholmod support" OFF)

if(DOWNLOAD_SUITESPARSE)
  if(NOT EXISTS "SuiteSparse.tar.gz")
    file(DOWNLOAD "http://www.cise.ufl.edu/research/sparse/SuiteSparse/SuiteSparse-${SS_VERSION}.tar.gz"
  	./SuiteSparse.tar.gz SHOW_PROGRESS)
  endif()
  execute_process(COMMAND cmake -E tar xzf "SuiteSparse.tar.gz")
endif()

find_file(SS_INSTALL README.txt DOC "README.txt in SuiteSparse folder"
	HINT "${CMAKE_BINARY_DIR}/.." NO_DEFAULT_PATH)
if(SS_INSTALL)
  get_filename_component(SS_DIR ${SS_INSTALL} PATH)
  if(NOT EXISTS "${SS_DIR}/README.txt")
    message(FATAL_ERROR "please give absolute path to SuiteSparse_install.m")
  endif()
else()
  set(SS_DIR "SuiteSparse-NOTFOUND")
endif()

if(SS_DIR)
  if(NOT WITH_BLAS)
    add_definitions(-DNBLAS)
  endif()

  if(EXISTS "${SS_DIR}/SuiteSparse_config")
    include_directories(${SS_DIR}/SuiteSparse_config)
    add_library(SuiteSparse_config ${SS_DIR}/SuiteSparse_config/SuiteSparse_config.c)
    install(FILES ${SS_DIR}/SuiteSparse_config/SuiteSparse_config.h
  	DESTINATION include/omc/c/suitesparse/Include)
    install(TARGETS SuiteSparse_config DESTINATION lib/omc/)
  elseif(EXISTS "${SS_DIR}/UFconfig")
    include_directories(${SS_DIR}/UFconfig)
    install(FILES ${SS_DIR}/UFconfig/UFconfig.h
  	DESTINATION include/omc/c/suitesparse/Include)
  else()
    message(ERROR "unknown suitesparse configuration")
  endif()

  if(WITH_CHOLMOD)
    include_directories(${SS_DIR}/CHOLMOD/Include)
    set(COLAMD_DIR ${SS_DIR}/COLAMD)
    include_directories(${COLAMD_DIR}/Include)
    
    #TODO: with CAMD and METIS
    add_definitions(-DNCAMD -DNPARTITION)

    #add colamd
    add_library(colamd_object OBJECT "${COLAMD_DIR}/Source/colamd_global.c"
                "${COLAMD_DIR}/Source/colamd.c")
    add_library(colamd_object_l OBJECT "${COLAMD_DIR}/Source/colamd.c") 
    get_target_property(FLAGS colamd_object_l COMPILE_DEFINITIONS)
    list(APPEND FLAGS "DLONG")
    set_target_properties(colamd_object_l PROPERTIES COMPILE_DEFINITIONS ${FLAGS})    
    add_library(colamd SHARED $<TARGET_OBJECTS:colamd_object> $<TARGET_OBJECTS:colamd_object_l>)
    
    install(TARGETS colamd DESTINATION lib/omc/)
    install(FILES ${COLAMD_DIR}/Include/colamd.h DESTINATION Include)

    set(CHOL_DIRS Core Check Cholesky MatrixOps Partition Modify Supernodal)
    unset(CHOL_SRC_FILES)
    foreach(curDir IN LISTS CHOL_DIRS)
      file(GLOB curFiles "${SS_DIR}/CHOLMOD/${curDir}/*.c")
      foreach(sFile IN LISTS curFiles)
        #get rid of those template files
        get_filename_component(TEST_FOR_T ${sFile} NAME_WE)
        if(${TEST_FOR_T} MATCHES "t_cholmod")
        else()
           list(APPEND CHOL_SRC_FILES ${sFile})
        endif()
      endforeach()
    endforeach()
    
    add_library(cholmod_object OBJECT ${CHOL_SRC_FILES})
    add_library(cholmod_object_l OBJECT ${CHOL_SRC_FILES}) 
    get_target_property(FLAGS cholmod_object_l COMPILE_DEFINITIONS)
    list(APPEND FLAGS "DLONG")
    set_target_properties(cholmod_object_l PROPERTIES COMPILE_DEFINITIONS ${FLAGS})    
    add_library(cholmod SHARED $<TARGET_OBJECTS:cholmod_object> $<TARGET_OBJECTS:cholmod_object_l>)
    
    install(TARGETS cholmod DESTINATION lib/omc/)
    #collect all cholmod includes
    file(GLOB cholH "${SS_DIR}/CHOLMOD/Include/cholmod*.h")
    foreach(curF IN LISTS cholH)
      if(${curF} MATCHES "cholmod_internal.h")
      else()
        install(FILES "${curF}" DESTINATION "Include")
      endif()
    endforeach()
  else()
    add_definitions(-DNCHOLMOD)
  endif()

  #collect and build the AMD part
  set(AMD_DIR "${SS_DIR}/AMD")
  include_directories(${AMD_DIR}/Include)
  include_directories(${AMD_DIR}/Source)
  install(DIRECTORY ${AMD_DIR}/Include
		DESTINATION include/omc/c/suitesparse)
  file(GLOB curFiles "${AMD_DIR}/Source/*.c")
  foreach(sFile IN LISTS curFiles)
    if(${sFile} MATCHES "amd_global.c")
      add_library(amd_global OBJECT ${sFile})
      set(AMD_OBJECTS "\$<TARGET_OBJECTS:amd_global>")
    else()
      list(APPEND AMD_SRC_FILES ${sFile})
    endif()
  endforeach()
  set(modes "DINT" "DLONG")
  foreach(mode IN LISTS modes)
    add_library(amd_${mode} OBJECT ${AMD_SRC_FILES})
    get_target_property(FLAGS amd_${mode} COMPILE_DEFINITIONS)
    list(APPEND FLAGS ${mode})
    set_target_properties(amd_${mode} PROPERTIES COMPILE_DEFINITIONS ${FLAGS})
    set(AMD_OBJECTS "${AMD_OBJECTS};\$<TARGET_OBJECTS:amd_${mode}>")
  endforeach()
  add_library(amd STATIC ${AMD_OBJECTS})
  install(TARGETS amd DESTINATION lib/omc/)
  
  include_directories(${SS_DIR}/UMFPACK/Include)
  include_directories(${SS_DIR}/UMFPACK/Source)
  install(DIRECTORY ${SS_DIR}/UMFPACK/Include
		DESTINATION include/omc/c/suitesparse)
  #collect the umfpack files
  #umfpack structure:
  #   *global, -: umfpack_(global | timer | tictoc).c
  #   *analyze, (DINT, DLONG): umf_(analyze | apply_order | colamd | cholmo |d free | fsize | is_permutation | malloc | realloc | report_perm | singletons).c
  #   *hsolve, (DINT, DLONG, ZINT, ZLONG) | (- | CONJUGATE_SOLVE) : umf_(ltsolve | utsolve).c
  #   *triplet, (DINT, DLONG, ZINT, ZLONG) | (- | DO_MAP | DO_VALUES) : umf_triplet.c
  #   *assemble, (DINT, DLONG, ZINT, ZLONG) | (-, FIXQ) : umf_assemble.c
  #   *store, (DINT, DLONG, ZINT, ZLONG) | (-, DROP) : umf_store_lu.c
  #   *solve, (DINT, DLONG, ZINT, ZLONG) | (-, WSOLVE) : umfpack_solve.c
  #   *others, (DINT, DLONG, ZINT, ZLONG) : *.c

  set(umfpack_dismiss_files umf_multicompile)
  set(umfpack_global_files umfpack_global umfpack_timer umfpack_tictoc)
  set(umfpack_global_groups "-")

  prepandAll(umfpack_analyze_files "umf_" analyze apply_order colamd cholmod free fsize is_permutation malloc realloc report_perm singletons)
  set(umfpack_analyze_groups DINT DLONG)
#  addToFlagGroup("umfpack_olib" "${umfpack_analyze_files}" "DINT;DLONG") 

  set(umfpack_hsolve_files umf_ltsolve umf_utsolve)
  getAllGroups(umfpack_hsolve_groups flags_umfpack_olib "DINT;DLONG;ZINT;ZLONG" "-;CONJUGATE_SOLVE")
  
  set(umfpack_triplet_files umf_triplet)
  getAllGroups(umfpack_triplet_groups flags_umfpack_olib "DINT;DLONG;ZINT;ZLONG" "-;DO_MAP;DO_VALUES;DO_MAP,DO_VALUES")

  set(umfpack_assemble_files umf_assemble)
  getAllGroups(umfpack_assemble_groups flags_umfpack_olib "DINT;DLONG;ZINT;ZLONG" "-;FIXQ")

  set(umfpack_store_files umf_store_lu)
  getAllGroups(umfpack_store_groups flags_umfpack_olib "DINT;DLONG;ZINT;ZLONG" "-;DROP")

  set(umfpack_solve_files umfpack_solve)
  getAllGroups(umfpack_solve_groups flags_umfpack_olib "DINT;DLONG;ZINT;ZLONG" "-;WSOLVE")

  set(umfpack_others_files "*")
  set(umfpack_others_groups "DINT;DLONG;ZINT;ZLONG")

  processGroups(umfpack "global;analyze;hsolve;triplet;assemble;store;solve" "${SS_DIR}/UMFPACK/Source/") 
  unset(UMFPACK_OBJECTS )
  foreach( olib IN LISTS list_umfpack_olib)
    add_library(${olib} OBJECT ${${olib}})
    list(LENGTH ${olib} olib_size)
    #message("files ${olib}: ${olib_size}")
    #message("flags_${olib}: ${flags_${olib}}")
    list(LENGTH flags_${olib} olib_size)
    if(${olib_size} GREATER 0)
      get_target_property(FLAGS ${olib} COMPILE_DEFINITIONS)
      foreach(f IN LISTS flags_${olib})
        list(APPEND FLAGS ${f})
      endforeach()
      set_target_properties(${olib} PROPERTIES COMPILE_DEFINITIONS "${FLAGS}")
    endif()
    set(UMFPACK_OBJECTS "${UMFPACK_OBJECTS};\$<TARGET_OBJECTS:${olib}>")
  endforeach()
  add_library(umfpack STATIC ${UMFPACK_OBJECTS})
  install(TARGETS umfpack DESTINATION lib/omc)


  set(PACKAGE_TITLE "small umfpack")
  set(PACKAGE_DESCRIPTION "reduced and selfcontained umfpack. fullversion is available at http://www.cise.ufl.edu/research/sparse/SuiteSparse/")
  set(CPACK_PACKAGE_NAME "small_umfpack")
  set(CPACK_GENERATOR "TGZ" "TBZ2" "ZIP")
  include(CPack)
else()
  message("could not find the suitesparse sources, so won't build anything")
endif()

=== SimulationRuntime/c/CMakeLists.txt ===
# Jens Frenkel, Jens.Frenkel@tu-dresden.de, 2011-10-11
# CMakefile for compilation of OMC

# CMAKE
CMAKE_MINIMUM_REQUIRED(VERSION 2.8)

# PROJECT
PROJECT(SimulationRuntimeC)

# Global Variables
IF(NOT OMCTRUNCHOME)
  SET(OMCTRUNCHOME ${CMAKE_CURRENT_SOURCE_DIR}/../../)
ENDIF (NOT OMCTRUNCHOME)

# OMDEV PATH
IF(NOT OMDEV)
  SET(OMDEV $ENV{OMDEV})
ENDIF(NOT OMDEV)

INCLUDE_DIRECTORIES(${OMDEV}/lib/expat-win32-msvc ${OMDEV}/include/lis ${OMDEV}/include/pthread)
link_directories(${OMDEV}/lib/expat-win32-msvc)
link_directories(${OMDEV}/lib/lapack-win32-msvc)

# SUNDIALS Header
FIND_PATH(SUNDIALS_INCLUDE_DIR sundials/sundials_config.h /usr/include /usr/local/include $ENV{INCLUDE} ${OMDEV}/lib/3rdParty/Sundials/include)

# SUNDIALS Libraires
FIND_LIBRARY(SUNDIALS_LIBRARY_CVODE      NAMES sundials_cvode      PATHS /usr/lib /usr/local/lib $ENV{LIB} ${OMDEV}/lib/3rdParty/Sundials/lib/release/vc100)
FIND_LIBRARY(SUNDIALS_LIBRARY_IDA        NAMES sundials_ida        PATHS /usr/lib /usr/local/lib $ENV{LIB} ${OMDEV}/lib/3rdParty/Sundials/lib/release/vc100)
FIND_LIBRARY(SUNDIALS_LIBRARY_NVEC       NAMES sundials_nvecserial        PATHS /usr/lib /usr/local/lib $ENV{LIB} ${OMDEV}/lib/3rdParty/Sundials/lib/release/vc100)
FIND_LIBRARY(SUNDIALS_KINSOL       NAMES sundials_kinsol        PATHS /usr/lib /usr/local/lib $ENV{LIB} ${OMDEV}/lib/3rdParty/Sundials/lib/release/vc100)

FIND_LIBRARY(SUNDIALS_LIBRARY_CVODED      NAMES sundials_cvoded      PATHS /usr/lib /usr/local/lib $ENV{LIB} ${OMDEV}/lib/3rdParty/Sundials/lib/debug/vc100)
FIND_LIBRARY(SUNDIALS_LIBRARY_IDAD        NAMES sundials_idad        PATHS /usr/lib /usr/local/lib $ENV{LIB} ${OMDEV}/lib/3rdParty/Sundials/lib/debug/vc100)
FIND_LIBRARY(SUNDIALS_LIBRARY_NVECD       NAMES sundials_nvecseriald        PATHS /usr/lib /usr/local/lib $ENV{LIB} ${OMDEV}/lib/3rdParty/Sundials/lib/debug/vc100)
FIND_LIBRARY(SUNDIALS_KINSOLD       NAMES sundials_kinsold        PATHS /usr/lib /usr/local/lib $ENV{LIB} ${OMDEV}/lib/3rdParty/Sundials/lib/debug/vc100)

IF(SUNDIALS_INCLUDE_DIR)

  INCLUDE_DIRECTORIES(${SUNDIALS_INCLUDE_DIR})

  if(SUNDIALS_LIBRARY_CVODE AND
   SUNDIALS_LIBRARY_IDA AND
   SUNDIALS_LIBRARY_NVEC AND
   SUNDIALS_KINSOL)

  SET(SUNDIALS_LIBRARIES ${SUNDIALS_LIBRARY_CVODE} ${SUNDIALS_LIBRARY_IDA} ${SUNDIALS_LIBRARY_NVEC} ${SUNDIALS_KINSOL})

ENDIF(SUNDIALS_LIBRARY_CVODE AND
      SUNDIALS_LIBRARY_IDA AND
   SUNDIALS_LIBRARY_NVEC AND
   SUNDIALS_KINSOL)

  if(SUNDIALS_LIBRARY_CVODED AND
   SUNDIALS_LIBRARY_IDAD AND
   SUNDIALS_LIBRARY_NVECD AND
   SUNDIALS_KINSOLD)

  SET(SUNDIALS_DEBUG_LIBRARIES ${SUNDIALS_LIBRARY_CVODED} ${SUNDIALS_LIBRARY_IDAD} ${SUNDIALS_LIBRARY_NVECD} ${SUNDIALS_KINSOLD})

ENDIF(SUNDIALS_LIBRARY_CVODED AND
      SUNDIALS_LIBRARY_IDAD AND
   SUNDIALS_LIBRARY_NVECD AND
   SUNDIALS_KINSOLD)

ENDIF(SUNDIALS_INCLUDE_DIR)

# Defines for Visual Studio
if(MSVC)
	add_definitions(-D_CRT_SECURE_NO_WARNINGS -DNOMINMAX -D_COMPLEX_DEFINED)
    # GC shall not use a dll
    add_definitions(-DGC_NOT_DLL)
endif(MSVC)

# includes
INCLUDE_DIRECTORIES(${OMCTRUNCHOME})
INCLUDE_DIRECTORIES(${OMCTRUNCHOME}/3rdParty/gc-7.2/include)
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR})
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/linearization)
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/math-support)
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/meta)
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/meta/gc)
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/simulation)
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/optimization)
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/simulation/libf2c)
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/simulation/results)
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/simulation/solver)
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/simulation/solver/initialization)
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/util)

# Subdirectorys
ADD_SUBDIRECTORY(math-support)
ADD_SUBDIRECTORY(meta)
ADD_SUBDIRECTORY(simulation)
ADD_SUBDIRECTORY(util)

# -------------------------------------------------------------
# MACRO definitions
# -------------------------------------------------------------

# Macros to hide/show cached variables.
# These two macros can be used to "hide" or "show" in the
# list of cached variables various variables and/or options
# that depend on other options.
# Note that once a variable is modified, it will preserve its
# value (hidding it merely makes it internal)

MACRO(HIDE_VARIABLE var)
  IF(DEFINED ${var})
    SET(${var} "${${var}}" CACHE INTERNAL "")
  ENDIF(DEFINED ${var})
ENDMACRO(HIDE_VARIABLE)

MACRO(SHOW_VARIABLE var type doc default)
  IF(DEFINED ${var})
    SET(${var} "${${var}}" CACHE "${type}" "${doc}" FORCE)
  ELSE(DEFINED ${var})
    SET(${var} "${default}" CACHE "${type}" "${doc}")
  ENDIF(DEFINED ${var})
ENDMACRO(SHOW_VARIABLE)

# MACRO BUILDMODEL
MACRO(BUILDMODEL model mo dir Flags CSRC)


  # includes
  INCLUDE_DIRECTORIES(${OMCTRUNCHOME}/SimulationRuntime/c)
  INCLUDE_DIRECTORIES(${OMCTRUNCHOME}/SimulationRuntime/c/linearization)
  INCLUDE_DIRECTORIES(${OMCTRUNCHOME}/SimulationRuntime/c/math-support)
  INCLUDE_DIRECTORIES(${OMCTRUNCHOME}/SimulationRuntime/c/meta)
  INCLUDE_DIRECTORIES(${OMCTRUNCHOME}/SimulationRuntime/c/meta/gc)
  INCLUDE_DIRECTORIES(${OMCTRUNCHOME}/SimulationRuntime/c/simulation)
  INCLUDE_DIRECTORIES(${OMCTRUNCHOME}/SimulationRuntime/c/simulation/libf2c)
  INCLUDE_DIRECTORIES(${OMCTRUNCHOME}/SimulationRuntime/c/simulation/results)
  INCLUDE_DIRECTORIES(${OMCTRUNCHOME}/SimulationRuntime/c/simulation/solver)
  INCLUDE_DIRECTORIES(${OMCTRUNCHOME}/SimulationRuntime/c/simulation/solver/initialization)
  INCLUDE_DIRECTORIES(${OMCTRUNCHOME}/SimulationRuntime/c/util)

  # OMDEV PATH
  IF(NOT OMDEV)
    SET(OMDEV $ENV{OMDEV})
  ENDIF(NOT OMDEV)

  INCLUDE_DIRECTORIES(${OMDEV}/lib/expat-win32-msvc)
  link_directories(${OMDEV}/lib/expat-win32-msvc)
  link_directories(${OMDEV}/lib/lapack-win32-msvc)

  # Variablen fuer openmodelica2sarturis
  SET(OMC_CODE   ${CMAKE_CURRENT_BINARY_DIR}/${model}.c
                 ${CMAKE_CURRENT_BINARY_DIR}/${model}_functions.c
                 ${CMAKE_CURRENT_BINARY_DIR}/${model}_init.txt)
  SET(OMC_OUTPUT  ${CMAKE_CURRENT_BINARY_DIR}/${model}.c
  #               ${CMAKE_CURRENT_BINARY_DIR}/${model}_functions.cpp
				  ${CMAKE_CURRENT_BINARY_DIR}/${model}_functions.h
				  ${CMAKE_CURRENT_BINARY_DIR}/${model}_records.c)

  # custom command fuer openmodelicacompiler
  ADD_CUSTOM_COMMAND(OUTPUT ${OMC_OUTPUT}
                     COMMAND ${OMC_DEBUG} ${Flags} +s ${dir}/${mo} Modelica ModelicaServices
                     WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
                     COMMENT "Erzeuge Code fuer ${model} with ${OMC_DEBUG}")

  # target fuer OM_OUTPUT
  ADD_CUSTOM_TARGET(${model}codegen ALL DEPENDS ${OMC_OUTPUT})

  ADD_EXECUTABLE(${model} ${OMC_OUTPUT} ${CSRC})
  TARGET_LINK_LIBRARIES(${model} simulation util math-support results solver f2c meta ModelicaExternalC libexpat initialization lapack_win32_MT)

  # Dependencies
  ADD_DEPENDENCIES(${model} ${model}codegen)

  IF(MODELS_INSTALL)
    INSTALL(TARGETS ${model} RUNTIME DESTINATION ${MODELS_INSTALL_PATH})
    INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/${model}_init.txt DESTINATION ${MODELS_INSTALL_PATH})
  ENDIF(MODELS_INSTALL)
#ENDFOREACH(model ${model_sources})
ENDMACRO(BUILDMODEL)

# MACRO BUILDMODEL
MACRO(BUILDMODELMOS model mos dir Flags CSRC)

IF(WIN32)
  SET(COPY copy)
else(WIN32)
  SET(COPY cp)
endif(WIN32)

IF(SUNDIALS_INCLUDE_DIR AND
   SUNDIALS_LIBRARY_CVODE AND
   SUNDIALS_LIBRARY_IDA AND
   SUNDIALS_LIBRARY_NVEC AND
   SUNDIALS_KINSOL)

  INCLUDE_DIRECTORIES(${SUNDIALS_INCLUDE_DIR})
  SET(SUNDIALS_LIBRARIES ${SUNDIALS_LIBRARY_CVODE} ${SUNDIALS_LIBRARY_IDA} ${SUNDIALS_LIBRARY_NVEC} ${SUNDIALS_KINSOL})

ENDIF(SUNDIALS_INCLUDE_DIR AND
      SUNDIALS_LIBRARY_CVODE AND
      SUNDIALS_LIBRARY_IDA AND
   SUNDIALS_LIBRARY_NVEC AND
   SUNDIALS_KINSOL)

  # includes
  INCLUDE_DIRECTORIES(${OMCTRUNCHOME}/SimulationRuntime/c)
  INCLUDE_DIRECTORIES(${OMCTRUNCHOME}/SimulationRuntime/c/linearization)
  INCLUDE_DIRECTORIES(${OMCTRUNCHOME}/SimulationRuntime/c/math-support)
  INCLUDE_DIRECTORIES(${OMCTRUNCHOME}/SimulationRuntime/c/meta)
  INCLUDE_DIRECTORIES(${OMCTRUNCHOME}/SimulationRuntime/c/meta/gc)
  INCLUDE_DIRECTORIES(${OMCTRUNCHOME}/SimulationRuntime/c/ModelicaExternalC)
  INCLUDE_DIRECTORIES(${OMCTRUNCHOME}/SimulationRuntime/c/simulation)
  INCLUDE_DIRECTORIES(${OMCTRUNCHOME}/SimulationRuntime/c/simulation/libf2c)
  INCLUDE_DIRECTORIES(${OMCTRUNCHOME}/SimulationRuntime/c/simulation/results)
  INCLUDE_DIRECTORIES(${OMCTRUNCHOME}/SimulationRuntime/c/simulation/solver)
  INCLUDE_DIRECTORIES(${OMCTRUNCHOME}/SimulationRuntime/c/simulation/solver/initialization)
  INCLUDE_DIRECTORIES(${OMCTRUNCHOME}/SimulationRuntime/c/util)

  INCLUDE_DIRECTORIES(${dir})

  # OMDEV PATH
  IF(NOT OMDEV)
    SET(OMDEV $ENV{OMDEV})
  ENDIF(NOT OMDEV)

  INCLUDE_DIRECTORIES(${OMDEV}/lib/expat-win32-msvc)
  link_directories(${OMDEV}/lib/expat-win32-msvc)
  link_directories(${OMDEV}/lib/lapack-win32-msvc)

  # custom command to copy expat.dll file
  SET(expat_CODE   ${OMDEV}/lib/expat-win32-msvc/libexpat.dll)
  STRING(REGEX REPLACE "/" "\\\\" expat_CODE_NEU ${expat_CODE})
  SET(expat_OUTPUT  ${CMAKE_CURRENT_BINARY_DIR}/RelWithDebInfo/libexpat.dll)
  STRING(REGEX REPLACE "/" "\\\\" expat_OUTPUT_NEU ${expat_OUTPUT})

    ADD_CUSTOM_COMMAND(OUTPUT ${expat_OUTPUT}
                     COMMAND ${COPY} ${expat_CODE_NEU} ${expat_OUTPUT_NEU}
                     WORKING_DIRECTORY ${dir}
                     COMMENT "copy file ${expat_CODE_NEU} to ${expat_OUTPUT_NEU}")
  # target fuer OM_OUTPUT
  ADD_CUSTOM_TARGET(expat${model} ALL DEPENDS ${expat_OUTPUT})


  SET(lapack_CODE   ${OMDEV}/lib/lapack-win32-msvc/lapack_win32_MT.dll)
  STRING(REGEX REPLACE "/" "\\\\" lapack_CODE_NEU ${lapack_CODE})
  SET(lapack_OUTPUT  ${CMAKE_CURRENT_BINARY_DIR}/RelWithDebInfo/lapack_win32_MT.dll)
  STRING(REGEX REPLACE "/" "\\\\" lapack_OUTPUT_NEU ${lapack_OUTPUT})

  ADD_CUSTOM_COMMAND(OUTPUT ${lapack_OUTPUT} ${blas_OUTPUT} ${lapack_OUTPUT}
                     COMMAND ${COPY} ${lapack_CODE_NEU} ${lapack_OUTPUT_NEU}
                     WORKING_DIRECTORY ${dir}
                     COMMENT "copy file ${lapack_CODE_NEU} to ${lapack_OUTPUT_NEU}")
  # target fuer OM_OUTPUT
  ADD_CUSTOM_TARGET(lapack${model} ALL DEPENDS ${lapack_OUTPUT})


  SET(blas_CODE   ${OMDEV}/lib/lapack-win32-msvc/blas_win32_MT.dll)
  STRING(REGEX REPLACE "/" "\\\\" blas_CODE_NEU ${blas_CODE})
  SET(blas_OUTPUT  ${CMAKE_CURRENT_BINARY_DIR}/RelWithDebInfo/blas_win32_MT.dll)
  STRING(REGEX REPLACE "/" "\\\\" blas_OUTPUT_NEU ${blas_OUTPUT})

  ADD_CUSTOM_COMMAND(OUTPUT ${blas_OUTPUT} ${blas_OUTPUT} ${lapack_OUTPUT}
                     COMMAND ${COPY} ${blas_CODE_NEU} ${blas_OUTPUT_NEU}
                     WORKING_DIRECTORY ${dir}
                     COMMENT "copy file ${blas_CODE_NEU} to ${blas_OUTPUT_NEU}")
  # target fuer OM_OUTPUT
  ADD_CUSTOM_TARGET(blas${model} ALL DEPENDS ${blas_OUTPUT})

  SET(OMC_MODELNAME ${model})
  # generate model.mos

  # Variablen fuer openmodelica2sarturis
  SET(OMC_CODE   ${dir}/${model}.c
                 ${dir}/${model}_functions.c
                 ${dir}/${model}_init.txt)
  SET(OMC_OUTPUT  ${dir}/${model}.c
  #                ${dir}/${model}_functions.cpp
				  ${dir}/${model}_functions.h
				  ${dir}/${model}_records.c)
  # custom command fuer openmodelicacompiler
  ADD_CUSTOM_COMMAND(OUTPUT ${OMC_OUTPUT}
                     COMMAND ${OMC_DEBUG} ${Flags} ${mos}
                     WORKING_DIRECTORY ${dir}
                     COMMENT "Generating code for ${model} with ${OMC_DEBUG}")
  # target fuer OM_OUTPUT
  ADD_CUSTOM_TARGET(${model}codegen ALL DEPENDS ${OMC_OUTPUT})

  ADD_CUSTOM_TARGET(${model}codegencpp ALL DEPENDS ${OMC_OUTPUT})

  ADD_DEFINITIONS(/TP)
  set_source_files_properties(${OMC_OUTPUT} PROPERTIES LANGUAGE CXX)
  ADD_EXECUTABLE(${model} ${OMC_OUTPUT} ${CSRC})

=== SimulationRuntime/cpp/CMakeLists.txt ===
# This skript will build and install all required libraries of the C++ Simulation-runtime
#
# The following conditional defines are passed to the c++ compiler:
#     if the Boost_log and Boost_setup_log libraries were found ->   -DUSE_BOOST_LOG
#     if the Boost_thread library was found ->                       -DUSE_BOOST_THREAD
#     if the Umfpack library of SuiteSparse was found ->             -DUSE_UMFPACK
#     if the PAPI library was found ->				                       -DUSE_PAPI
#     if the Sundials libraries were found ->                        -DPMC_USE_SUNDIALS
#     if the runtime is build for the omc ->                         -DOMC_BUILD
#
# Additionally it is possible to link all libraries statically (experimental), therefor -DANALYZATION_MODE=ON musst be passed to cmake
#
# The used defines are stored in the SYSTEM_CFLAGS variable, which is passed to the ModelicaConfig.inc and written in the PrecompiledHeader.cmake

CMAKE_MINIMUM_REQUIRED (VERSION 2.6)
PROJECT(CppSolverInterface)



#Set Options
OPTION(ANALYZATION_MODE "ANALYZATION_MODE" OFF)
OPTION(USE_THREADS "USE_PARALLEL_OUTPUT" OFF)


#Set Variables
SET(MODELICAEXTERNALCDIR  "${CMAKE_SOURCE_DIR}/../../libraries/Resources/C-Sources")
SET(USERTABDIR  "${CMAKE_SOURCE_DIR}/../../libraries/Resources/Data/Tables")

SET(LIBINSTALLEXT "cpp")
SET(MODELICA_MODEL "ModelicaSystem")
SET(LIBPREFIX "OMCpp")
SET(SolverName ${LIBPREFIX}Solver)
SET(SystemName ${LIBPREFIX}System)
SET(OMCFactoryName ${LIBPREFIX}OMCFactory)
SET(MathName ${LIBPREFIX}Math)
SET(ModelicaExternalName ModelicaExternalC)
SET(ModelicaTablesName ModelicaStandardTables)
SET(SimulationSettings ${LIBPREFIX}SimulationSettings)
SET(SimControllerName ${LIBPREFIX}SimController)
SET(CVodeName ${LIBPREFIX}CVode)
SET(EulerName ${LIBPREFIX}Euler)
SET(IdaName ${LIBPREFIX}Ida)
SET(IdasName ${LIBPREFIX}Idas)
SET(KinsolName ${LIBPREFIX}Kinsol)
SET(ModelicaName ${LIBPREFIX}Modelica)
SET(NewtonName ${LIBPREFIX}Newton)
SET(HybrjName ${LIBPREFIX}Hybrj)
SET(UmfPackName ${LIBPREFIX}UmfPack)
SET(DataExchangeName ${LIBPREFIX}DataExchange)
SET(ModelicaUtilitiesName ${LIBPREFIX}ModelicaUtilities)
SET(ExtensionUtilitiesName ${LIBPREFIX}ExtensionUtilities)
SET(BasiLibName ${LIBPREFIX}Base)

SET(USE_MICO OFF)
SET(REDUCE_DAE OFF)
SET(USE_SUNDIALS ON)
SET(OMC_BUILD ON)
SET(SIMSTER_BUILD OFF)

SET(Boost_USE_STATIC_LIBS OFF)
SET(Boost_USE_MULTITHREADED ON)
SET(Boost_USE_STATIC_RUNTIME OFF)


# Handle Analyzation mode
IF(NOT ANALYZATION_MODE)
	#Precompiled header produces problems if the compiler is not "g++" but "scorep g++"
	INCLUDE(${CMAKE_SOURCE_DIR}/PrecompiledHeader.cmake)
	MESSAGE(STATUS "Analyzation mode disabled")
ELSE(NOT ANALYZATION_MODE)
	MESSAGE(STATUS "Using analyzation mode")
	ADD_DEFINITIONS(-DANALYZATION_MODE)	
ENDIF(NOT ANALYZATION_MODE )


# Handle parallel output
IF(USE_PARALLEL_OUTPUT)
	ADD_DEFINITIONS(-DUSE_PARALLEL_OUTPUT)
ENDIF(USE_PARALLEL_OUTPUT)


# Handle build type
IF(OMC_BUILD)
  ADD_DEFINITIONS(-DOMC_BUILD)
ELSEIF(SIMSTER_BUILD)
  ADD_DEFINITIONS(-DSIMSTER_BUILD)
ENDIF(OMC_BUILD)


# Handle OMDEV
#  - On windows boost,blas,lapack and sundial solvers from omdev are used else the installed versions are used
IF(WIN32)
	SET(ENV{BOOST_ROOT} $ENV{OMDEV}"/lib/3rdParty/boost-1_55/")
	SET(BLAS_blas_LIBRARY $ENV{OMDEV}/lib/3rdParty/Lapack/Lib/blas_win32.dll CACHE FILEPATH "Blas library")
	SET(LAPACK_lapack_LIBRARY  $ENV{OMDEV}/lib/3rdParty/Lapack/Lib/lapack_win32.dll CACHE FILEPATH "Lapack library")
	SET(BLAS_DIRY "$ENV{OMDEV}/lib/3rdParty/Lapack/Lib/" CACHE LOCATION "where was yarp built?")

	# Disable Optimization for RelWithDebInfo on Windows
	IF(MSVC)
		STRING(REPLACE "/O2" "/Od" CMAKE_CXX_FLAGS_RELWITHDEBINFO ${CMAKE_CXX_FLAGS_RELWITHDEBINFO})
	ELSE(MSVC)
		STRING(REPLACE "/O2" "/O0" CMAKE_CXX_FLAGS_RELWITHDEBINFO ${CMAKE_CXX_FLAGS_RELWITHDEBINFO})
		STRING(REPLACE "/O2" "/O0" CMAKE_CXX_FLAGS_DEBUG ${CMAKE_CXX_FLAGS_DEBUG})
	ENDIF(MSVC)

	#set mico paths
	SET(MICO_LIB_HOME $ENV{OMDEV}/lib/mico-msys-mingw/)
	SET(MICO_INCLUDE_HOME  $ENV{OMDEV}/include/mico-msys-mingw/)
	#set sundials solvers include and library directories
	SET(SUNDIALS_INLCUDE_HOME  $ENV{OMDEV}/lib/3rdParty/Sundials/include)

	IF(MSVC)
		SET(SUNDIALS_LIBRARY_RELEASE_HOME  $ENV{OMDEV}/lib/3rdParty/Sundials/lib/release/vc100)
	ELSEIF(MINGW)
		SET(SUNDIALS_LIBRARY_RELEASE_HOME  $ENV{OMDEV}/lib/3rdParty/Sundials/lib/release/mingw/dlls)
	ENDIF(MSVC)
	
	SET(INSTALL_OMDEV_LIBS ON)
ENDIF(WIN32)


# Find CMinpack
# Note: Visual Studio libs are located in install/msvc, libs for gcc are directly in install
IF(MSVC)
    SET(CMinpack_Path "${CMAKE_SOURCE_DIR}/../../3rdParty/CMinpack/install/msvc")
ELSE(MSVC)
    SET(CMinpack_Path "${CMAKE_SOURCE_DIR}/../../3rdParty/CMinpack/install")
ENDIF(MSVC)

FIND_PATH(CMINPACK_INCLUDE_DIR cminpack.h
          HINTS ${CMinpack_Path}
          PATH_SUFFIXES include include/cminpack include/cminpack-1)

FIND_LIBRARY(CMINPACK_LIBRARY
             NAMES cminpack
             HINTS ${CMinpack_Path}
             PATH_SUFFIXES lib lib64)

INCLUDE_DIRECTORIES(${CMINPACK_INCLUDE_DIR})


# Find PAPI
FIND_LIBRARY(PAPI_LIBRARIES NAMES libpapi.a papi)
FIND_PATH(PAPI_INCLUDE_DIRS NAMES papi.h)
INCLUDE(FindPackageHandleStandardArgs)
FIND_PACKAGE_HANDLE_STANDARD_ARGS(PAPI DEFAULT_MSG PAPI_LIBRARIES PAPI_INCLUDE_DIRS)
IF(PAPI_FOUND)
  ADD_DEFINITIONS(-DUSE_PAPI)
ENDIF(PAPI_FOUND)


# Find Boost
#  - The optional boost libraries must be searched separately, otherwise no library is found if just one is missing.
#  - Additionaly the Boost_LIBRARIES variable is overwritten each time find_package(Boost ...) is called, thus it must be rescued
FIND_PACKAGE(Boost COMPONENTS log log_setup)
SET(Boost_LIBRARIES_TMP ${Boost_LIBRARIES_TMP} ${Boost_LIBRARIES})
IF(Boost_LOG_FOUND AND Boost_LOG_SETUP_FOUND)
	ADD_DEFINITIONS(-DUSE_BOOST_LOG)
	MESSAGE(STATUS "Using boost log")
ELSE(Boost_LOG_FOUND AND Boost_LOG_SETUP_FOUND)
	MESSAGE(STATUS "Boost log disabled")
	UNSET(Boost_LOG_LIBRARY)
ENDIF(Boost_LOG_FOUND AND Boost_LOG_SETUP_FOUND)

FIND_PACKAGE(Boost COMPONENTS thread atomic)

SET(Boost_LIBRARIES_TMP ${Boost_LIBRARIES_TMP} ${Boost_LIBRARIES})
FIND_PACKAGE(Threads)
IF(Boost_THREAD_FOUND AND Boost_ATOMIC_FOUND)
	ADD_DEFINITIONS(-DUSE_BOOST_THREAD)
	#ADD_DEFINITIONS(-DUSE_PARALLEL_OUTPUT)
	MESSAGE(STATUS "Using boost thread")
ELSE(Boost_THREAD_FOUND AND Boost_ATOMIC_FOUND)
	MESSAGE(STATUS "Boost thread disabled")
ENDIF(Boost_THREAD_FOUND AND Boost_ATOMIC_FOUND)

FIND_PACKAGE(Boost COMPONENTS filesystem system serialization program_options REQUIRED)
SET(Boost_LIBRARIES_TMP ${Boost_LIBRARIES_TMP} ${Boost_LIBRARIES})
SET(Boost_LIBRARIES ${Boost_LIBRARIES_TMP})
MESSAGE(STATUS "Boost Libraries")
MESSAGE(STATUS ${Boost_LIBRARIES})


# Find Lapack and Blas
FIND_PACKAGE(BLAS)
FIND_PACKAGE(LAPACK)

IF(MSVC)
  #workaround  because cmake does not find the lapack libraries for Visual Studio 10
  SET(LAPACK_MSVC_10  $ENV{OMDEV}/lib/3rdParty/Lapack/Lib/lapack_win32.lib  )
  SET(BLAS_MSVC_10 $ENV{OMDEV}/lib/3rdParty/Lapack/Lib/blas_win32.lib )
  SET(LAPACK_LIBRARIES  ${LAPACK_MSVC_10}   ${BLAS_MSVC_10} )

ELSEIF(MINGW)
  SET(LAPACK_MINGW  $ENV{OMDEV}/lib/3rdParty/Lapack/Lib/lapack_win32.dll  )
  SET(BLAS_MINGW $ENV{OMDEV}/lib/3rdParty/Lapack/Lib/blas_win32.dll )
  SET(LAPACK_LIBRARIES  ${LAPACK_MINGW}   ${BLAS_MINGW} )
ENDIF(MSVC)

FIND_LIBRARY(mkl_rt mkl_rt)
IF (mkl_rt)
  #workaround because find_package(lapack)-command returns the wrong libraries on Taurus (ZIH-TU Dresden)
  SET(LAPACK_LIBRARIES ${mkl_rt})
ENDIF(mkl_rt)

MESSAGE(STATUS "Lapack Libraries")
MESSAGE(STATUS ${LAPACK_LIBRARIES})


# Find Sundials solvers
IF(USE_SUNDIALS)
  FIND_PATH(SUNDIALS_INCLUDE_DIR cvode/cvode.h
      PATHS ${SUNDIALS_INLCUDE_HOME})
  MESSAGE(STATUS ${SUNDIALS_INCLUDE_DIR})

  FIND_LIBRARY(SUNDIALS_NVECSERIAL_LIB "sundials_nvecserial"
      PATHS ${SUNDIALS_LIBRARY_RELEASE_HOME})
  FIND_LIBRARY(SUNDIALS_CVODES_LIB "sundials_cvodes"
      PATHS ${SUNDIALS_LIBRARY_RELEASE_HOME} )
  FIND_LIBRARY(SUNDIALS_IDA_LIB "sundials_ida"
      PATHS ${SUNDIALS_LIBRARY_RELEASE_HOME} )
  FIND_LIBRARY(SUNDIALS_KINSOL_LIB "sundials_kinsol"
      PATHS ${SUNDIALS_LIBRARY_RELEASE_HOME} )
  #FIND_LIBRARY(SUNDIALS_IDAS_LIB "sundials_idas"
  #    PATHS ${SUNDIALS_LIBRARY_RELEASE_HOME} )

  SET(SUNDIALS_LIBS ${SUNDIALS_NVECSERIAL_LIB}  ${SUNDIALS_CVODES_LIB}  ${SUNDIALS_IDA_LIB}  ${SUNDIALS_KINSOL_LIB})

  MESSAGE(STATUS "Sundials Libraries:")
  MESSAGE(STATUS ${SUNDIALS_LIBS})
  ADD_DEFINITIONS(-DPMC_USE_SUNDIALS)

  # On Windows we need to install those libraries along with the SimManager
  INSTALL(FILES ${SUNDIALS_LIBS} DESTINATION bin)
ENDIF(USE_SUNDIALS)


#Handle umfpack
FIND_PACKAGE(SuiteSparse HINTS "${CMAKE_SOURCE_DIR}/Solver/UmfPack/")
IF(SuiteSparse_found)
	MESSAGE(STATUS "Using UmfPack")
	INCLUDE_DIRECTORIES(${SUITESPARSE_INCLUDE_DIRS})
	ADD_DEFINITIONS(-DUSE_UMFPACK)
    SET(SUITESPARSE_INCLUDE ${SUITESPARSE_INCLUDE_DIRS})
	SET(UMFPACK_LIB ${SUITESPARSE_LIBRARIES})
ELSE(SuiteSparse_found)
	MESSAGE(STATUS "UmfPack disabled")
	SET(SUITESPARSE_INCLUDE ".")
	SET(UMFPACK_LIB "")
ENDIF(SuiteSparse_found)


#Handle Mico corba
IF(USE_MICO)
  FIND_LIBRARY(MICO_LIBRARY  mico2313
    PATHS ${MICO_LIB_HOME}) #you can add additional search paths for mico library
  FIND_PATH(MICO_INCLUDE_DIR CORBA.h
     ${MICO_INCLUDE_HOME}) #you can add additional search paths for mico include
  MESSAGE(STATUS ${MICO_LIBRARY})
  MESSAGE(STATUS ${MICO_INCLUDE_DIR})
ENDIF(USE_MICO)


#Write the defines into the ADDITIONAL_DEFINES variable
# GET_DIRECTORY_PROPERTY(ADDITIONAL_DEFINES DEFINITIONS)
# message(STATUS "Generated compile definitions: ${ADDITIONAL_DEFINES}")

link_directories ( ${Boost_LIBRARY_DIRS} )


include_directories (${Boost_INCLUDE_DIR})
include_directories ("${PROJECT_SOURCE_DIR}")
include_directories ("${PROJECT_BINARY_DIR}")

message(STATUS "Boost dirs '${Boost_LIBRARY_DIRS}', '${Boost_INCLUDE_DIR}'")

#build of simulation.core
include_directories ("Include")


add_subdirectory (Core/Math)

add_subdirectory (Core/Utils/Modelica)
add_subdirectory (Core/Utils/extension)
add_subdirectory (Core/DataExchange)
add_subdirectory (SimCoreFactory/OMCFactory)

#add system default implemention project
add_subdirectory (Core/System)
#add solver default implemention project
add_subdirectory (Core/Solver)
add_subdirectory (Core/SimulationSettings)
#add_subdirectory (Core/SimController)
add_subdirectory (Core/Modelica)
add_subdirectory (Core/ModelicaExternalC)
add_subdirectory (Core/SimController)
#build of simulation.solver
include_directories ("Include/Solver")
#add  Euler solver project
add_subdirectory (Solver/Euler)
add_subdirectory (Solver/Newton)
add_subdirectory (Solver/Hybrj)
add_subdirectory (Solver/UmfPack)



if(REDUCE_DAE)
  add_subdirectory(ReduceDAE/Implementation)
endif()



if(USE_SUNDIALS)
#add  Cvode solver project
add_subdirectory (Solver/CVode)
add_subdirectory (Solver/Kinsol)
#add  Idas solver project
#add_subdirectory (Solver/Idas/Implementation)
#add_subdirectory (Solver/Ida/Implementation)
GET_TARGET_PROPERTY(libCVode ${CVodeName} LOCATION)
GET_FILENAME_COMPONENT(libCVodeName ${libCVode} NAME)

GET_TARGET_PROPERTY(libKinsol ${KinsolName} LOCATION)
GET_FILENAME_COMPONENT(libKinsolName ${libKinsol} NAME)
#GET_TARGET_PROPERTY(libIdas ${IdasName} LOCATION)
#GET_FILENAME_COMPONENT(libIdasName ${libIdas} NAME)
#GET_TARGET_PROPERTY(libIda ${IdaName} LOCATION)
#GET_FILENAME_COMPONENT(libIdaName ${libIda} NAME)

#set (IDAS_LIB ${libIdasName})
set (CVODE_LIB ${libCVodeName})
set (KINSOL_LIB ${libKinsolName})
#set (IDA_LIB ${libIdaName})
endIf()

GET_TARGET_PROPERTY(libNewton ${NewtonName} LOCATION)
GET_FILENAME_COMPONENT(libNewtonName ${libNewton} NAME)

GET_TARGET_PROPERTY(libUmfPack ${UmfPackName} LOCATION)
GET_FILENAME_COMPONENT(libUmfPackName ${libUmfPack} NAME)

GET_TARGET_PROPERTY(libEuler ${EulerName} LOCATION)
GET_FILENAME_COMPONENT(libEulerName ${libEuler} NAME)

GET_TARGET_PROPERTY(libHybrj ${HybrjName} LOCATION)

=== SimulationRuntime/cpp/Makefile ===
# Adrian Pop, adrpo@ida.liu.se, 2006-02-01
# Makefile for compilation of OMC using OMDev-mingw
# OMDev-mingw: http://www.ida.liu.se/~adrpo/omc/omdev/

top_builddir = ../../..
builddir_build=$(top_builddir)/build
builddir_bin=$(top_builddir)/build/bin
builddir_lib=$(top_builddir)/build/lib/omc
builddir_inc=$(top_builddir)/build/include/omc

ANALYZATION_MODE_COMMAND="-DANALYZATION_MODE=ON"
PARALLEL_OUTPUT_COMMAND="-DUSE_PARALLEL_OUTPUT=ON"

runtimeCpp: clean
ifneq ("$(ANALYZATION_MODE)","true")
	$(eval ANALYZATION_MODE_COMMAND="")
endif
ifneq ("$(USE_PARALLEL_OUTPUT)","true")
	$(eval PARALLEL_OUTPUT_COMMAND="")
endif
	cd ./Build && echo "change to Build" && cmake $(ANALYZATION_MODE_COMMAND) $(PARALLEL_OUTPUT_COMMAND) -DCMAKE_BUILD_TYPE=RelWithDebInfo -DCMAKE_INSTALL_PREFIX:PATH="$(builddir_build)"  ../
	$(MAKE) -C Build VERBOSE=1; 

install: runtimeCpp
	(cd Build; $(MAKE) install)

clean:
	rm -R -f Build
	mkdir Build

=== SimulationRuntime/interactive/CMakeLists.txt ===
# includes
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/../c)
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/../c/linearization)
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/../c/math-support)
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/../c/meta)
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/../c/meta/gc)
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/../c/ModelicaExternalC)
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/../c/simulation)
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/../c/util)
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/../c/simulation/libf2c)
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/../c/simulation/results)
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/../c/simulation/solver)

# Quellen und Header
SET(interactive_sources  omi_Calculation.cpp omi_Control.cpp omi_ResultManager.cpp
				 omi_ServiceInterface.cpp omi_Transfer.cpp socket.cpp thread.cpp)

SET(interactive_headers  omi_Calculation.h omi_Control.h omi_ResultManager.h
                         omi_ServiceInterface.h omi_Transfer.h socket.h thread.h)

# Library util
ADD_LIBRARY(interactive ${interactive_sources} ${interactive_headers})
#TARGET_LINK_LIBRARIES(util)

# Install
INSTALL(TARGETS interactive
		ARCHIVE DESTINATION lib)

INSTALL(FILES ${interactive_headers} DESTINATION include)

=== tools/rml2mod/Makefile ===
## RMLHOME=/home/x05emica/utils/rml/rml-2.2/x86-linux-gcc/
SHELL =/bin/sh
RMLHOME=/c/OMDEV/tools/rml/
#RMLHOME=/c/bin/cygwin/home/adrpo/rml-2.3.0/x86-mingw32-gcc
#RMLHOME=/c/bin/cygwin/home/adrpo/rml-2.3.0/x86-cygwin-gcc
#RMLHOME=/c/dev/rml/rml-mmc-2.3.3-cygwin-mingw/x86-cygwin-gcc
CC = gcc #-g
LD = gcc #-g
RML=${RMLHOME}/bin/rmlc #-Wr,-ftrace #-Wc,-g
CCFLAGS=-I${RMLHOME}/include/plain/
LDFLAGS=-L${RMLHOME}/lib/plain/ -lrml

all: rml2mod

build: parser.o lexer.o yacclib.o absyn.o rmldump.o \
	rmlrefactor.o rmltomod.o moddump.o modrefactor.o extern.o lookup.o rml-db-parse.o rml-db-scan.o loadprogramdb.o

parser.o parser.h: parser.y absyn.h defs.h
	bison -t -d -v --output-file="parser.c" parser.y
	$(CC) $(CCFLAGS) -c parser.c

lexer.o: lexer.c parser.h defs.h
	$(CC) -c lexer.c

yacclib.o: yacclib.c yacclib.h
	$(CC) $(CCFLAGS) -c yacclib.c

rmldump.h rmldump.c:rmldump.rml absyn.h
	$(RML)  -c rmldump.rml

rmldump.o: rmldump.c rmldump.h absyn.h
	$(RML) -c rmldump.c

rmlrefactor.h rmlrefactor.c:rmlrefactor.rml absyn.h
	$(RML)  -c rmlrefactor.rml

rmlrefactor.o: rmlrefactor.c  absyn.h
	$(RML) -c rmlrefactor.c

rmltomod.h rmltomod.c:rmltomod.rml absyn.h
	$(RML)  -c rmltomod.rml

rmltomod.o: rmltomod.c  absyn.h
	$(RML) -c rmltomod.c

modrefactor.h modrefactor.c:modrefactor.rml absyn.h
	$(RML)  -c modrefactor.rml

modrefactor.o: modrefactor.c absyn.h
	$(RML) -c modrefactor.c

modrefactortypes.h modrefactortypes.c:modrefactortypes.rml absyn.h
	$(RML)  -c modrefactortypes.rml

modrefactortypes.o: modrefactortypes.c absyn.h
	$(RML) -c modrefactortypes.c

moddump.h moddump.c:moddump.rml absyn.h
	$(RML)  -c moddump.rml

moddump.o: moddump.c absyn.h
	$(RML) -c moddump.c

lookup.h lookup.c:lookup.rml absyn.h
	$(RML)  -c lookup.rml

lookup.o: lookup.c absyn.h
	$(RML) -c lookup.c

dictionary.h dictionary.c:dictionary.rml absyn.h
	$(RML)  -c dictionary.rml

dictionary.o: dictionary.c absyn.h
	$(RML) -c dictionary.c

util.h util.c:util.rml
	$(RML)  -c util.rml

util.o: util.c
	$(RML) -c util.c

#print.h print.c:print.rml
#	$(RML) -g -c print.rml

#print.o: print.c print.h
#	$(RML) -c print.o

absyn.h absyn.c: absyn.rml
	$(RML)  -c absyn.rml

absyn.o: absyn.c absyn.h
	$(CC) -c absyn.c

scanparse.o: scanparse.c absyn.h
	$(RML) -c scanparse.c

rml-db-parse.c rml-db-parse.h: rml-db-parse.y
	bison -p yyrmldb --defines --output-file=rml-db-parse.c rml-db-parse.y

rml-db-scan.c: rml-db-scan.l rml-db-parse.h
	flex -Pyyrmldb rml-db-scan.l

rml-db-scan.o: rml-db-scan.c rml-db-parse.h
	$(CC) $(CCFLAGS) -c rml-db-scan.c

rml-db-parse.o: rml-db-parse.c rml-db-scan.o
	$(CC) $(CCFLAGS) -c rml-db-parse.c

loadprogramdb.o: loadprogramdb.c absyn.h rml-db-parse.h
	$(RML) -c loadprogramdb.c

external.o: external.c
	$(RML) -c external.c

main.c main.h: main.rml scanparse.o loadprogramdb.o rml-db-parse.o
	$(RML)  -c main.rml

main.o: main.c main.h scanparse.o rmldump.h rmldump.o rmlrefactor.h rmlrefactor.o \
	rmltomod.h  rmltomod.o moddump.h moddump.o modrefactor.h modrefactor.o \
		modrefactortypes.h modrefactortypes.o parser.o yacclib.o lexer.o \
        rml-db-parse.o rml-db-scan.o loadprogramdb.o util.o external.o lookup.h lookup.o \
        dictionary.h dictionary.o
	$(RML) -c main.c `ls *.o`

rml2mod: main.o
	$(RML) -o rml2mod `ls *.o`

clean:
	rm -f *~ *.o *.rdb scanparse.h main.h main.c ptpest parser.h \
		parser.c rmldump.h rmldump.c absyn.h absyn.c \
		rmlrefactor.h rmlrefactor.c rmltomod.h rmltomod.c \
		moddump.h moddump.c rml2mod rml-db-*.c rml-db-*.h \
		loadprogramdb.h util.h util.c external.h modrefactor.h modrefactor.c

=== SimulationRuntime/c/meta/CMakeLists.txt ===
# Sources and Headers
SET(META_SRC 	meta_modelica_builtin.c
				meta_modelica_string_lit.c
				realString.c
				meta_modelica_catch.c
				meta_modelica.c
				meta_modelica_segv.c
				gc/mmc_gc.c)

SET(META_HFILES rml_compatibility.h
                meta_modelica_builtin.h
				meta_modelica_builtin_boxptr.h
				meta_modelica_segv.h
				meta_modelica_string_lit.h
				meta_modelica.h
				gc/mmc_gc.h)


# Library meta
add_library(meta  ${META_SRC} ${META_HFILES})
#set_property(TARGET f2c PROPERTY PREFIX lib)

# Install
INSTALL(TARGETS meta
		ARCHIVE DESTINATION lib/omc)
#INSTALL(FILES ${META_HFILES} DESTINATION include/meta)

=== SimulationRuntime/c/simulation/CMakeLists.txt ===
# Jens Frenkel, Jens.Frenkel@tu-dresden.de, 2011-10-11
# CMakefile for compilation of OMC

# Subdirectorys
ADD_SUBDIRECTORY(libf2c)
ADD_SUBDIRECTORY(results)
ADD_SUBDIRECTORY(solver)

# Include Directory of expat
INCLUDE_DIRECTORIES("${OMCTRUNCHOME}/3rdParty/FMIL/ThirdParty/Expat/expat-2.0.1/lib")

# Quellen und Header
SET(simulation_sources  options.c simulation_input_xml.cpp simulation_runtime.cpp
					    ../linearization/linearize.cpp
						modelinfo.c simulation_info_xml.c)

SET(simulation_headers options.h simulation_input_xml.h simulation_runtime.h modelinfo.h simulation_info_xml.h
					../linearization/linearize.h ../simulation_data.h ../omc_inline.h ../util/omc_msvc.h ../openmodelica.h ../openmodelica_func.h)

# Library util
ADD_DEFINITIONS(/DNO_INTERACTIVE_DEPENDENCY)
ADD_LIBRARY(simulation ${simulation_sources} ${simulation_headers})
#TARGET_LINK_LIBRARIES(util)

# Install
INSTALL(TARGETS simulation
		ARCHIVE DESTINATION lib/omc)

#INSTALL(FILES ${simulation_headers} DESTINATION include)

=== testsuite/openmodelica/bootstrapping/Makefile ===
# BuiltinReal.mos fails when using Cevalfunc.mo! the values are OK, the display is different! 
TEST = ../../rtest

TESTFILES = \
DebugTest.mos \
DumpTest.mos \
GraphTest.mos \
HashTableTest.mos \
PriorityQueue.mos \
SimCodeTest.mos \
SimplifyTest.mos \
SusanTest.mos \
System.mos \
UtilTest.mos

# test that currently fail. Move up when fixed. 
# Run make testfailing
FAILINGTESTFILES= \


# Dependency files that are not .mo .mos or Makefile
# Add them here or they will be cleaned.
DEPENDENCIES = \
*.mo \
*.mos \
Makefile \
BreakProcess.cpp \
LinkMain.makefile.in \
LinkMain.makefile.mingw \
SusanTestSmall.tpl \
main.c \
main_records.c \
main_separate.c \
refactor-mc-to-m.sh

# Remove executables on Linux (no extension)
# CLEAN = $(TESTFILES:.mos=) $(TESTFILES:.mos=_*) $(TESTFILES:.mos=.cpp) $(TESTFILES:.mos=.makefile) $(TESTFILES:.mos=.libs) $(TESTFILES:.mos=.log) output.log *.dll *.exe *.so

CLEAN = `ls | grep -w -v -f deps.tmp`

.PHONY : test

test:
	@echo
	@echo Running tests...
	@echo
	@echo OPENMODELICAHOME=" $(OPENMODELICAHOME) "
	@$(TEST) $(TESTFILES)
	
# Cleans all files that are not listed as dependencies 
clean :
	@echo $(DEPENDENCIES) | sed 's/ /\\|/g' > deps.tmp
	@rm -f $(CLEAN)

# Run this if you want to list out the files (dependencies).
# do it after cleaning and updating the folder
# then you can get a list of file names (which must be dependencies
# since you got them from repository + your own new files)
# then add them to the DEPENDENCIES. You can find the 
# list in deps.txt 
getdeps: 
	@echo $(DEPENDENCIES) | sed 's/ /\\|/g' > deps.tmp
	@echo $(CLEAN) | sed -r 's/deps.txt|deps.tmp//g' | sed 's/ / \\\n/g' > deps.txt	
	@echo Dependency list saved in deps.txt.
	@echo Copy the list from deps.txt and add it to the Makefile @DEPENDENCIES
	
failingtest :
	@echo
	@echo Running failing tests...
	@echo
	@$(TEST) $(FAILINGTESTFILES)

=== 3rdParty/modelica3d/backends/osg-gtk/CMakeLists.txt ===
find_package(GtkGl REQUIRED)
find_package(OpenSceneGraph REQUIRED osgGA osgText osgViewer osgDB)

if(MINGW)
add_definitions(-std=c++0x -U__STRICT_ANSI__ -mms-bitfields)
elseif ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
  if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS "3.3")
    message("clang <3.3 detected; changing to default c++ instead since clang 3.0~3.2 are not good enough for the used headers")
    set(CMAKE_CXX_COMPILER c++)
  endif()
add_definitions(-std=c++0x)
else ()
add_definitions(-std=c++0x)
endif(MINGW)

#requires osg, gtk and proc3d
include_directories(${Boost_INCLUDE_DIR} ${GTK_INCLUDE_DIRS} "${CMAKE_SOURCE_DIR}/lib/proc3d/src/" ${GTKGL_INCLUDE_DIRS} ${OPENSCENEGRAPH_INCLUDE_DIRS})
link_directories(${GTK_LIBRARY_DIRS} ${GTKGL_LIBRARY_DIRS})

set(osg-gtk_src "${CMAKE_SOURCE_DIR}/backends/osg-gtk/src/")

add_library(m3d-osg-gtk SHARED
  "${osg-gtk_src}/osg_interpreter.hpp"
  "${osg-gtk_src}/osgviewerGTK.hpp"
  "${osg-gtk_src}/osgviewerGTK.cpp"
  "${osg-gtk_src}/osggtkdrawingarea.h"
  "${osg-gtk_src}/osggtkdrawingarea.cpp"
  )
add_dependencies(m3d-osg-gtk proc3d)

target_link_libraries(m3d-osg-gtk ${OPENSCENEGRAPH_LIBRARIES} ${GTK_LIBRARIES} ${GTKGL_LIBRARIES} proc3d)

add_executable(viewer "${osg-gtk_src}/viewer.cpp")
target_link_libraries(viewer m3d-osg-gtk)

install(TARGETS m3d-osg-gtk
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib
)

install(FILES "python/dbus-server.py"
  DESTINATION "lib/omlibrary-modelica3d/osg-gtk")

=== 3rdParty/modelica3d/lib/proc3d/CMakeLists.txt ===
find_package(Boost REQUIRED)

if(MINGW)
add_definitions(-std=c++0x -fPIC -U__STRICT_ANSI__)
else(MINGW)
add_definitions(-std=c++0x -fPIC)
endif(MINGW)

include_directories(${Boost_INCLUDE_DIR})
set(proc3d_src "${CMAKE_SOURCE_DIR}/lib/proc3d/src/")

add_library(proc3d SHARED "${proc3d_src}/proc3d.cpp")

install(TARGETS proc3d
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib
)

=== SimulationRuntime/c/simulation/libf2c/CMakeLists.txt ===
# Sources and Headers
set(MISC
  f77vers.c i77vers.c main.c s_rnge.c abort_.c exit_.c getarg_.c iargc_.c
  getenv_.c signal_.c s_stop.c s_paus.c system_.c cabs.c
  derf_.c derfc_.c erf_.c erfc_.c sig_die.c uninit.c)
set(POW pow_ci.c pow_dd.c pow_di.c pow_hh.c pow_ii.c pow_ri.c pow_zi.c pow_zz.c)
set(CX 	c_abs.c c_cos.c c_div.c c_exp.c c_log.c c_sin.c c_sqrt.c)
set(DCX	z_abs.c z_cos.c z_div.c z_exp.c z_log.c z_sin.c z_sqrt.c)
set(REAL r_abs.c r_acos.c r_asin.c r_atan.c r_atn2.c r_cnjg.c r_cos.c
  r_cosh.c r_dim.c r_exp.c r_imag.c r_int.c
  r_lg10.c r_log.c r_mod.c r_nint.c r_sign.c
  r_sin.c r_sinh.c r_sqrt.c r_tan.c r_tanh.c)
set(DBL	d_abs.c d_acos.c d_asin.c d_atan.c d_atn2.c
  d_cnjg.c d_cos.c d_cosh.c d_dim.c d_exp.c
  d_imag.c d_int.c d_lg10.c d_log.c d_mod.c
  d_nint.c d_prod.c d_sign.c d_sin.c d_sinh.c
  d_sqrt.c d_tan.c d_tanh.c)
set(INT i_abs.c
  i_dim.c i_dnnt.c i_indx.c i_len.c i_mod.c i_nint.c i_sign.c
  lbitbits.c lbitshft.c)
set(HALF h_abs.c h_dim.c h_dnnt.c h_indx.c h_len.c h_mod.c h_nint.c h_sign.c)
set(CMP l_ge.c l_gt.c l_le.c l_lt.c hl_ge.c hl_gt.c hl_le.c hl_lt.c)
set(EFL	ef1asc_.c ef1cmc_.c)
set(CHAR f77_aloc.c s_cat.c s_cmp.c s_copy.c)
set(I77 backspac.c close.c dfe.c dolio.c due.c endfile.c err.c
  fmt.c fmtlib.c ftell_.c iio.c ilnw.c inquire.c lread.c lwrite.c
  open.c rdfmt.c rewind.c rsfe.c rsli.c rsne.c sfe.c sue.c
  typesize.c uio.c util.c wref.c wrtfmt.c wsfe.c wsle.c wsne.c xwsne.c)
set(QINT pow_qq.c qbitbits.c qbitshft.c ftell64_.c)
set(TIME dtime_.c etime_.c)

configure_file(sysdep1.h0 ${CMAKE_CURRENT_SOURCE_DIR}/sysdep1.h COPYONLY)
configure_file(signal1.h0 ${CMAKE_CURRENT_SOURCE_DIR}/signal1.h COPYONLY)

SET(f2c_headers f2c.h
			    fio.h
			    sysdep1.h
			    fmt.h
#			    math.h
			    signal1.h
			    lio.h
			    fp.h
			    rawio.h)


# If you get an error compiling dtime_.c or etime_.c, try adding
# -DUSE_CLOCK to the CFLAGS assignment above; if that does not work,
# omit ${TIME} from OFILES  assignment below.

# To get signed zeros in write statements on IEEE-arithmetic systems,
# add -DSIGNED_ZEROS to the CFLAGS assignment below and add signbit.c
# to the end of the OFILES  assignment below.

# For INTEGER*8 support (which requires system-dependent adjustments to
# f2c.h), add ${QINT} to the OFILES  assignment below...
#add_executable(arithchk arithchk.c)
#if(UNIX)
#  target_link_libraries(arithchk m)
#endif()
#set_target_properties(arithchk PROPERTIES COMPILE_DEFINITIONS
#  "NO_FPINIT;NO_LONG_LONG")
#ADD_CUSTOM_COMMAND(
#   OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/arith.h
#   COMMAND arithchk > ${CMAKE_CURRENT_BINARY_DIR}/arith.h
#   DEPENDS arithchk
#   )


set(OFILES  ${MISC} ${POW} ${CX} ${DCX} ${REAL} ${DBL} ${INT}
  ${HALF} ${CMP} ${EFL} ${CHAR} ${I77} ${TIME})
# Library f2c
if(WIN32)
  ADD_DEFINITIONS(/D_COMPLEX_DEFINED /DUSE_CLOCK /DMSDOS /DNO_ONEXIT /D_MSC_VER /D__STDC__ /D_CRT_SECURE_NO_DEPRECATE)
ELSE(WIN32)
  ADD_DEFINITIONS(-fPIC -DNON_UNIX_STDIO)
ENDIF(WIN32)
add_library(f2c  ${OFILES} ${f2c_headers})
#set_property(TARGET f2c PROPERTY PREFIX lib)

# Install
INSTALL(TARGETS f2c
		ARCHIVE DESTINATION lib/omc)
#INSTALL(FILES f2c.h DESTINATION include)

=== debian/changelog ===
openmodelica (22929-1) unstable; urgency=low

  * Automatic subversion build
 -- OpenModelica Build System <build@openmodelica.org>  Sat, 25 Oct 2014 07:22:13 +0200

=== debian/control ===
Source: openmodelica
Section: math
Priority: optional
Maintainer: OpenModelica Build System <build@openmodelica.org>
Build-Depends: debhelper (>= 7.0.0),
 clang,
 automake,
 libtool,
 libncurses5-dev,
 libsqlite3-dev,
 cmake (>= 2.8.6),
 libssl-dev (>= 0.9.8g),
 libreadline-dev,
# ParadisEO requires this
 g++-4.4,
 gfortran,
 time,
 libqt4-dev (>= 4.4.3),
# Force libqtwebkit-dev when squeeze is removed
 libqtwebkit-dev | libqt4-dev (>= 4.4.3),
# libqwt-dev (>= 5.1.1) | libqwt5-qt4-dev (>= 5.1.1),
 liblpsolve55-dev (>= 5.5.0.10),
 rml-mmc (>= 260),
 openjdk-6-jdk | sun-java6-jdk,
 libomniorb4-dev,
 omniidl4 | omniidl (>= 4.0.0),
 omniidl4-python | omniidl-python,
 python-omniorb,
# precise doesn't handle hdf5 properly
 libhdf5-serial-dev | libhdf5-dev,
 libhwloc-dev,
 gnuplot,
 xsltproc,
 flex,
 paradiseo,
 bison,
 libf2c2-dev,
 liblapack-dev,
 autoconf,
 zip,
 unzip,
 libexpat1-dev,
 libsundials-serial-dev,
# Not in squeeze...
# libsundials-kinsol1,
 libgtkglext1-dev,
 libopenscenegraph-dev,
 libboost-all-dev,
 libdbus-1-dev
Standards-Version: 3.8.4

Package: openmodelica
Section: math
Architecture: any
Depends: omc,
 ompython,
 omplot,
 omlib-modelica-3.2.1,
 omshell,
 omshell-terminal,
 omnotebook,
 drmodelica,
 drcontrol,
 omedit,
 omoptim,
 ${misc:Depends}
Description: A complete Modelica environment
 The goal of the project is to create a complete Modelica modeling, compilation
 and simulation environment based on free software distributed in binary and
 source code form.
 .
 This package is a Debian metapackage. After installation this package can be
 removed. This metapackage pulls in the following OpenModelica packages:
 .
 1. Package omc the OpenModelica Compiler/Interpreter (omc)
 2. Package omshell the OpenModelica Shell (OMShell)
 3. Package omshell-terminal the OpenModelica Shell-terminal (OMShell-terminal)
 4. Package omlib-msl32 the Modelica Standard Library version 3.2.1
 5. Package omnotebook the OpenModelica Notebook, with DrModelica and DrControl
 6. Package omedit, a Modelica connection editor for OpenModelica
 7. Package omoptim, a tool for optimization of Modelica models
 8. Package omplot, the plot tools for OpenModelica

Package: omc
Section: math
Architecture: any
Depends: clang,
# sun-java6-jre | openjdk-6-jre, # Should no longer be needed
 build-essential,
 gnuplot,
 xsltproc,
 libf2c2-dev,
 libexpat1-dev,
 libsundials-serial-dev,
 liblapack-dev,
 zip,
 unzip,
 libdbus-1-dev,
 ${shlibs:Depends},
 ${misc:Depends}
Recommends: python-beautifulsoup,
 omplot,
 libsaxonb-java
Description: The OpenModelica Compiler
 This is the core of the OpenModelica project. It can be used stand-alone as
 a compiler. It is recommended to use it together with an OpenModelica client,
 such as OMShell (textual interface), OMNotebook (for teaching purposes)
 or OMEdit (graphical modeling).

Package: omc-bootstrapped
Section: math
Architecture: any
Depends: omc,
 ${shlibs:Depends},
 ${misc:Depends}
Description: The OpenModelica Compiler (Bootstrapped version)
 Alternative version of the OpenModelica compiler, compiled using bootstrapping.
 This will become the default compiler in the future. For now you can test it
 using this package.

Package: omc-doc
Section: math
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends}
Description: OpenModelica manuals
 Contains large pdf-manuals for OpenModelica

Package: omc-java
Section: math
Architecture: any
Depends: omc, ${shlibs:Depends},
 ${misc:Depends}
Description: OpenModelica Java interface
 Contains jar-files to interface with OpenModelica

Package: omplot
Section: math
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends}
Description: Plot tool for OpenModelica
 This tool is essential for using the plot() command in omc.

Package: ompython
Section: math
Architecture: any
Depends: python-omniorb,
 python-pyparsing,
 ${shlibs:Depends},
 ${misc:Depends}
Description: Python interface for OpenModelica
 A python CORBA interface for OpenModelica.

Package: omedit
Section: math
Architecture: any
Depends: omc,
 omlib-modelica-3.2.1,
 omlib-modelicareference,
 ${shlibs:Depends},
 ${misc:Depends}
Description: A Modelica connection editor for OpenModelica
 OMEdit is still in active development. Please try it out and give feedback.

Package: omoptim
Section: math
Architecture: any
Depends: omc,
 gnuplot,
 ${shlibs:Depends},
 ${misc:Depends}
Description: A Modelica optimization tool for OpenModelica

Package: omnotebook
Section: math
Architecture: any
Depends: omc,
 ${shlibs:Depends},
 ${misc:Depends}
Recommends: drmodelica,
 drcontrol
Description: A Mathematica-style Notebook for OpenModelica

Package: drmodelica
Section: math
Architecture: any
Depends: omnotebook,
 ${shlibs:Depends},
 ${misc:Depends}
Description: An OMNotebook course in the Modelica language
 The course is based on Peter Fritzson's book
 “Principles of Object-Oriented Modeling and Simulation with Modelica 2.1”.

Package: drcontrol
Section: math
Architecture: any
Depends: omnotebook,
 ${shlibs:Depends},
 ${misc:Depends}
Description: An OMNotebook course in basic control theory

Package: omshell-terminal
Section: math
Architecture: any
Depends: omc,
 ${shlibs:Depends},
 ${misc:Depends}
Description: A text-based interface to OpenModelica (based on readline)

Package: omshell
Section: math
Architecture: any
Depends: omc,
 ${shlibs:Depends},
 ${misc:Depends}
Description: A text-based interface to OpenModelica (based on Qt)

Package: libmodelica3d
Section: math
Architecture: any
Depends: omlib-modelicaservices-3.2.1-modelica3d,
 ${shlibs:Depends},
 ${misc:Depends}
Description: A lightweight, platform-independent 3D-visualisation library for Modelica

Package: libomccpp
Section: math
Architecture: any
Depends: libboost-dev,
 libboost-filesystem-dev,
 libboost-system-dev,
 libboost-serialization-dev,
 libboost-program-options-dev,
 ${shlibs:Depends},
 ${misc:Depends}
Description: Libraries for the C++ code generation target of OpenModelica

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# OpenModelica debian/rules that uses debhelper.
# Based on a sample file with GNU copyright 1997 to 1999 by Joey Hess.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

ARCH ?= $(shell uname -m | sed s/i[0-9]86/x86/)

# Some variables to install binaries under debian/tmp
DEST   = $(CURDIR)/debian/tmp
SRCD   = $(CURDIR)

CFLAGS = -Wall

#CC = gcc
#CXX = g++

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif

#ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
#  NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
MAKEFLAGS += -j$(shell grep -c processor /proc/cpuinfo)
#endif

# march=pentium4 used to be enabled because omc required sse2 regardless
# ifeq (x86,$(ARCH))
#        CFLAGS += -march=pentium4
# endif
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	INSTALL_PROGRAM += -s
endif

configure: configure.in
	autoconf

config.status: configure
	dh_testdir
	echo $(DEB_BUILD_OPTIONS)
	# Add here commands to configure the package.
	RMLHOME=/usr CFLAGS="$(CFLAGS)" ./configure \
	CC=clang CXX=clang++ OMPCC="gcc -fopenmp" \
	--host=$(DEB_HOST_GNU_TYPE) \
	--build=$(DEB_BUILD_GNU_TYPE) \
	--prefix=/usr \
	--with-lapack="-llapack -lblas" \
	--with-omniORB=/usr \
	--disable-rml-trace \
	--without-ipopt
#       --with-static-sqlite=`test -f /usr/lib/*/libsqlite3.a && echo /usr/lib/*/libsqlite3.a || echo /usr/lib/libsqlite3.a` \
#	--with-static-lpsolve=/usr
#	--with-static-readline=/usr

build: build-stamp

build-stamp:  config.status
	dh_testdir

	# Add here commands to compile the package.
	$(MAKE) $(MAKEFLAGS) NOLIBRARIES=Yes release mosh omlibrary qtclients
	cp build/bin/omc build/bin/omc-rml
	$(MAKE) $(MAKEFLAGS) NOLIBRARIES=Yes runtimeCPPinstall
	$(MAKE) $(MAKEFLAGS) NOLIBRARIES=Yes omc-bootstrapped
	cp build/bin/omc build/bin/omc-bootstrapped
	rm build/bin/omc
	# Qtclients will start make omc again
	# This is a good thing as Susan will then run and regenerate SimCodeC
	# Skip it due to ModelicaBuiltin not existing
	# $(MAKE) release
	# Skip the testsuite log. People can look it up on hudson
	# bash -c "(ulimit -t 600 && cd testsuite/partest && /usr/bin/time -f '== Testsuite wall-time: %e' ./runtests.pl -nocolour)" > ./build/share/doc/omc/testsuite.txt 2>&1
	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp 
	# Add here commands to clean up after the build process.
	dh_clean 

install: build
	dh_testdir
	dh_testroot
	dh_prep 
	dh_installdirs -popenmodelica -Pdebian/tmp
	# Add here commands to install the package into debian/tmp.
	$(MAKE) $(MAKEFLAGS) install DESTDIR=$(DEST)
	# We add our own Debian-specific copyright file
	rm -f $(DEST)/usr/share/doc/omc/COPYING
	dh_install

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs 
	dh_installdocs
	dh_installexamples
	dh_install
	dh_installmenu
	dh_installmime
	dh_installman
	dh_link
	dh_strip
	# dh_compress -X.pdf -X.onb -X.c -X.h -X.mo -X.mos -Xomc_helptext.txt -X.py
	dh_fixperms
	dh_installdeb
	dh_makeshlibs -V
	dh_shlibdeps -l/usr/lib/omc -Lomc -- --ignore-missing-info
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install
